# pandas.read_fwf

`pandas.``read_fwf`(filepath_or_buffer: Union[str, pathlib.Path, IO[AnyStr]], colspecs='infer', widths=None, infer_nrows=100, **kwds)

  Read a table of fixed-width formatted lines into DataFrame.

  Also supports optionally iterating or breaking of the file into chunks.

  Additional help can be found in the online docs for IO Tools.

  Parameters:

  filepath_or_buffer : str, path object or file-like object

  > Any valid string path is acceptable. The string could be a URL. Valid URL schemes include http, ftp, s3, and file. For file URLs, a host is expected. A local file could be: `file://localhost/path/to/table.csv`.

  > If you want to pass in a path object, pandas accepts any `os.PathLike`.

  > By file-like object, we refer to objects with a `read()` method, such as a file handler (e.g. via builtin `open` function) or `StringIO`.

  colspecs : list of tuple (int, int) or ‘infer’. optional

  > A list of tuples giving the extents of the fixed-width fields of each line as half-open intervals (i.e., [from, to[ ). String value ‘infer’ can be used to instruct the parser to try detecting the column specifications from the first 100 rows of the data which are not being skipped via skiprows (default=’infer’).

  widths : list of int, optional

  > A list of field widths which can be used instead of ‘colspecs’ if the intervals are contiguous.

  infer_nrows : int, default 100

  > The number of rows to consider when letting the parser determine the colspecs.

  > New in version 0.24.0.

  **kwds : optional

  > Optional keyword arguments can be passed to `TextFileReader`.

  Returns:

  DataFrame or TextParser

  > A comma-separated values (csv) file is returned as two-dimensional data structure with labeled axes.

  See also

  `to_csv`
    Write DataFrame to a comma-separated values (csv) file.
  `read_csv`
    Read a comma-separated values (csv) file into DataFrame.

  Examples

      >>> pd.read_fwf('data.csv')  # doctest: +SKIP

Scroll To Top